import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import konstanten.Konst;
import animation.EinachserAnimation;

import simulator.Simulator;
import integrator.*;
import modell.*;

public class Einachser extends PApplet
{
    int SPEED = 2;

    double phi1=0.0;
    double phi2=0.0;

    int position = 0;
    boolean AKTIV=false;
    Button knopf;
    
    EinachserAnimation animation;
    
    EinachserModell modell;
    RuKuIntegrator    integrator;
    Simulator simulator;
    
    double[] parameter = {2.0,0.02};
//    double[] anfangsbedingungen = {0.0, 0.0, Math.PI-0.5, 0.0};
//    double[] anfangsbedingungen = {0.0, 0.0, Math.PI*0.5, 0.0};
    double[] anfangsbedingungen = {0.0, 0.0, 0.5, 0.0};
    
    int index=0;
    
    public void setup()
    {
        setLayout(null);
        knopf = new Button("Animation");
        knopf.setBounds(10,300,120,30);
        knopf.addActionListener(new Knopflauscher());
        add(knopf);        
        
        modell = new EinachserModell();
        modell.setzeParameter(parameter);
        integrator = new RuKuIntegrator();
        integrator.registriereModell(modell);
        simulator = new Simulator(modell,integrator);
        
        animation = new EinachserAnimation(this);
        
        size(Konst.BREITE,Konst.HOEHE);
        frameRate(10);
    }

    public void draw()
    {
        clear();
        strokeWeight(2.0f);
        
        animation.draw(phi1,phi2);
        
        if(AKTIV)
        {            
            phi1=simulator.y[0][index];
            phi2=simulator.y[2][index];
                            
            index+=SPEED;
            if(index>=simulator.t.length)
                index=0;
        }

        knopf.repaint();
        
    }
    
    private class Knopflauscher implements ActionListener
    {
        public void actionPerformed(ActionEvent ee)
        {
            AKTIV=!AKTIV;
            if(AKTIV)
            {
                index=0;
                simulator.simulieren(parameter,anfangsbedingungen,0.0,2.0,0.002);
                knopf.setBackground(Color.RED);
            }   
            else
            {
                knopf.setBackground(Color.GREEN);
            }
        }        
    }
    
    public static void main(String[] passedArgs) 
    {
        String[] appletArgs = new String[] { "Einachser" };
        if(passedArgs != null) 
        {
             PApplet.main(concat(appletArgs, passedArgs));
        } 
        else 
        {
            PApplet.main(appletArgs);
        }            
    }
}
